;
;
; Copper.asm                                                  
;
; Usando retrazos horizontales y verticales cambiamos las componentes de la
; paleta del color de fondo (0) para simular franjas horizontales que si
; son colocadas en forma de gradientes simulan una barra grfica en modo 
; 320x200x256 (puede aplicarse tambin en modo texto).
;
; Para entender el algoritmo con ms facilidad
; ver la versin C (ms sencilla) en COPPERC.C.
;
; 1996, [NoP]/Compiler
;
;

        .MODEL SMALL
        .STACK 200H
        .386                         

        .DATA
 
 incremento  db  ?             ; incremento de direccin (1  -1)
 posicion    db  ?             ; posicin de la barra.


        .CODE

main:
        mov ax, 13h
        int 10h                ; inicializar 320x200x256, para obligar al
                               ; windows a poner pantalla completa.

        mov [posicion], 0      ; posicin inicial que queremos
        mov [incremento], 1    ; direccin inicial que queremos

        call Copper

        mov ax, 3
        int 10h

        mov ah, 4ch
        int 21h                ; Salir al DOS


;
; Copper PROC
; Procedimiento de creacin de una Copper Bar en modo texto.
;

Copper   PROC
        
        pusha

inicio:
        cli
vertical1: 
        mov dx, 03dah
        in al, dx
        and al, 8         
        jnz vertical1
vertical2: 
        in al, dx
        and al, 8
        jz vertical2                   ; esperar Retrazo Vertical

        xor ch, ch
        mov cl, [posicion]             ; CX = posicion
        cmp [posicion], 200            ;  es cx < 250 ?
        jna bajando                    ; menor, la barra an baja.
        mov [incremento], -1           ; mayor, restar 1 en vez de sumar.
                                       
bajando:
        cmp posicion, 5                ; lmite superior
        jnb subiendo                   ; si nos lo hemos pasado invert. barra
        mov [incremento], 1
subiendo:
        mov al, [incremento]
        add [posicion], al             ; posicion += incremento
        mov cl, [posicion]             ; cx = posicion

hretrace:

horiz1:
        mov dx, 03dah
        in al, dx
        and al, 1
        jnz horiz1
horiz2: 
        in al, dx
        and al, 1
        jz horiz2                      ; esperamos Retrazo Horizontal

        loop hretrace   ; Se espera POSICION veces al retrazo horizontal para
                        ; empezar a dibujar -> nos coloca en la 1 lnea de
                        ; la barra.
        
        xor cx, cx                     ; cx=contador para cambiar la paleta

negro_a_verde:          

horizstart:
        mov dx, 03dah
        in al, dx
        and al, 1
        jnz horizstart       ; Esperarse al comienzo del retrazo horizontal
        
        xor al, al            ; al = color
        mov dx, 3c8h
        out dx, al            ; Seleccionar el color 0
        inc dx                ; dx = 3c9h
        out dx, al            ; R = 0
        mov ax, cx       
        out dx, al            ; G = CX ( 0 to 63 )
        xor al, al
        out dx, al            ; B = 0      -CAMBIAR LA PALETA DEL COLOR 0-
        
        mov dx, 03dah
horizend:
        in al, dx
        and al, 1
        jz horizend            ; Esperarse al final del retrazo horizontal

        inc cx
        cmp cx, 63
        jnz negro_a_verde      ; Ejecuta el bucle 63 veces (63 tonos de verde)


verde_a_negro:

horizstart2:
        mov dx, 03dah
        in al, dx
        and al, 1
        jnz horizstart2      ; Esperarse al comienzo del retrazo horizontal
        
        xor al, al           ; al = 0 
        mov dx, 03c8h
        out dx, al           ; Seleccionar el Color 7
        inc dx               ; dx = 3c9h
        out dx, al           ; R = 0
        mov ax, cx       
        out dx, al           ; G = CX ( 0 to 63 )
        xor al, al
        out dx, al           ; B = 0      -CAMBIAR LA PALETA DEL COLOR 0-
        
        mov dx, 03DAh
horizend2:
        in al, dx
        and al, 1
        jz horizend2       ; Esperarse al final del retrazo horizontal

        loop verde_a_negro   ; Ejecuta el bucle 63 veces

        sti

        mov ah, 1
        int 16h
        jz inicio            ; mientras no pulse una tecla repetir.
        
        popa
        ret                  ; volvemos 
Copper ENDP


END main

